import * as React from 'react';
import type { LayersManagerProps, LayersManagerState, LayersContextProps } from './types';
export declare const LayersContext: React.Context<LayersContextProps>;
export declare const Provider: React.Provider<LayersContextProps>;
export declare const Consumer: React.Consumer<LayersContextProps>;
export default class LayersManager extends React.Component<LayersManagerProps, LayersManagerState> {
    host: React.RefObject<HTMLElement>;
    containerRef: React.RefObject<any>;
    constructor(props: LayersManagerProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    onDocumentClick: (event: MouseEvent) => void;
    onKeyUp: (event: KeyboardEvent) => void;
    onAddEscapeHandler: (escapeKeyHandler: () => unknown) => void;
    onRemoveEscapeHandler: (escapeKeyHandler: () => unknown) => void;
    onAddDocClickHandler: (docClickHandler: (event: MouseEvent) => unknown) => void;
    onRemoveDocClickHandler: (docClickHandler: (event: MouseEvent) => unknown) => void;
    render(): JSX.Element;
}
